/*
	this file is under GPL
*/

#include <windows.h>
#include <cstring>
#include <kmeleon_plugin.h>
#include "jconv_lib.h"

using namespace std;

#define PLUGIN_NAME "Japanese encoding conversion plugin"

long DoMessage(const char *to, const char *from, const char *subject,
               long data1, long data2);

kmeleonPlugin kPlugin = {
	KMEL_PLUGIN_VER,
	PLUGIN_NAME,
	DoMessage
};

long DoMessage(const char *to, const char *from, const char *subject,
               long data1, long data2)
{
	if (to[0] == '*' || stricmp(to, kPlugin.dllname) == 0) {
		char **p = (char **)data2;
		if (stricmp(subject, "ToJIS") == 0) {
			*p = sjis2jis((char *)data1);
		} else if (stricmp(subject, "ToEUC") == 0) {
			*p = sjis2euc((char *)data1);
		} else if (stricmp(subject, "HanToZen") == 0) {
			*p = han2zen((char *)data1);
		} else if (stricmp(subject, "Escape") == 0) {
			*p = escape((char *)data1);
		} else if (stricmp(subject, "EncodeUTF8") == 0) {
			*p = kPlugin.kFuncs->EncodeUTF8((char *)data1);
		} else if (stricmp(subject, "DecodeUTF8") == 0) {
			*p = kPlugin.kFuncs->DecodeUTF8((char *)data1);
		}
		else return 0;
		return 1;
	}
	return 0;
}

extern "C" {
	KMELEON_PLUGIN kmeleonPlugin *GetKmeleonPlugin() {
		return &kPlugin;
	}

	KMELEON_PLUGIN int DrawBitmap(DRAWITEMSTRUCT *dis) {
		return 14; // 14 = icon width
	}
}
